//importing required modules
import { csv, select } from 'd3';
import { scatterPlot } from './scatterPlot';

// dataset
const csvUrl =
  'https://gist.githubusercontent.com/saineethanakorn/eb66bf87c8cd87e742b15913c34b3fc3/raw/da7ccf2d7ca66e57fb043e2b76dc5a89f49ada93/XAGUSD60.csv';

const parseRow = (d) => {
  d.mpg = +d.mpg;
  d.hp = +d.hp;
  return d;
};

const width = window.innerWidth;
const height = window.innerHeight - 100;
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

const main = async () => {
  const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(await csv(csvUrl, parseRow))
    .xValue((d) => d.hp)
    .yValue((d) => d.mpg)
    .margin({
      top: 20,
      right: 20,
      bottom: 40,
      left: 50,
    })
    .radius(5);

  svg.call(plot);

  // setting dynamic axes
  const columns = ['hp', 'mpg'];
  let i = 0;
  setInterval(() => {
    plot.xValue((d) => d[columns[i % columns.length]]);
    svg.call(plot);
    i++;
  }, 1000);
};

main();
